<template>
  <div class="map-pannel">
    <div
      style="padding:10px; text-align:right"
      class="xs-pad-top30x"
    >
      <el-button
        type="primary"
        @click="showRoute"
        size="small"
      >
        {{ routeBtn }}
      </el-button>
      <el-button
        type="primary"
        @click="getNewLocation"
        size="small"
      >
        Update Route
      </el-button>
      <el-button
        type="primary"
        @click="getBroadcast"
        size="small"
      >
        SOS
      </el-button>
    </div>
    <div id="mapContainer" />
  </div>
</template>

<script>
import 'leaflet/dist/leaflet.css'
import L from 'leaflet'
// import LRoutingMachine from './LRoutingMachine'
import axios from 'axios'
import 'leaflet-routing-machine'
import baseUrl from '@/config'

export default {
  name: 'LeafletMap',
  data () {
    return {
      map: null,
      currentLocation: {},
      red: 'https://maps.google.com/mapfiles/kml/paddle/red-circle.png',
      yellow: 'https://maps.google.com/mapfiles/kml/paddle/ylw-circle.png',
      blue: 'https://maps.google.com/mapfiles/kml/paddle/blu-circle.png',
      routeBtn: 'Show Route',
      isDisplay: false,
      control: null
    }
  },
  mounted () {
    this.map = L.map('mapContainer').setView([0, 0], 12)
    L.tileLayer('https://{s}.tile.osm.org/{z}/{x}/{y}.png', {
      attribution:
        '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors'
    }).addTo(this.map)
    this.geoLocation()
  },
  beforeDestroy () {
    if (this.map) {
      this.map.remove()
    }
  },
  methods: {
    showRoute () {
      if (!this.isDisplay) {
        this.control._container.style.display = 'block'
        this.routeBtn = 'Hide Route'
      } else {
        this.control._container.style.display = 'none'
        this.routeBtn = 'Show Route'
      }
      this.isDisplay = !this.isDisplay
    },
    getNewLocation () {
      const URL = baseUrl.baseUrl_NodeProxy + '/update_location'
      axios.get(URL)
        .then(response => {
          console.log('res', response.data)
          this.$notify({
            title: 'Note',
            message: 'Location Updated.'
          })
          this.afterUpdateLocation()
        })
        .catch(error => {
          console.log('err', error.message)
          this.$notify({
            title: 'Note',
            message: 'Connection Issue.'
          })
        })
    },
    afterUpdateLocation () {
      if (!this.$route.path.includes('/maps')) {
        this.$router.push('/maps')
      }
    },
    getBroadcast () {
      if (this.isDisplay) {
        this.showRoute()
      }
      const URL = baseUrl.baseUrl_NodeProxy + '/broadcast'
      let locationDetails = {}
      if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(position => {
          locationDetails.lat = position.coords.latitude
          locationDetails.lang = position.coords.longitude
          locationDetails.clientID = localStorage.getItem('DeviceIP')
          // window.open('https://maps.google.com/?q=' + locationDetails.lat + ',' + locationDetails.lang, '_blank')
          // let locationDetailsStr = JSON.stringify(locationDetails)
          // console.log('latlogstr', locationDetailsStr)
          console.log('latlog', locationDetails)
          axios.post(URL, locationDetails).then(response => {
            console.log('res', response.data)
            this.getSOSData()
          })
        })
      } else {
        alert('location service not working')
      }
    },
    getSOSData () {
      const URL = baseUrl.baseUrl_NodeProxy + '/getSOS'
      this.deviceIP = localStorage.getItem('DeviceIP')
      console.log('new', this.deviceIP)
      // const URL = 'https://192.168.1.5:5000/getSOS'
      let _this = this
      axios.get(URL).then(response => {
        let dd = response.data
        _this.map.panTo(new L.LatLng(_this.currentLocation.lat, _this.currentLocation.lng))
        for (var i = 0; i < dd.length; i++) {
          if (dd[i][3] === this.deviceIP) continue
          let greenIcon = L.icon({
            iconUrl: _this.blue,
            iconSize: [25, 25]
          })
          L.marker([dd[i][0], dd[i][1]], { icon: greenIcon }).addTo(_this.map)
        }
        // L.tileLayer('https://{s}.tile.osm.org/{z}/{x}/{y}.png', {
        //   attribution:
        //    '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors'
        // }).addTo(_this.map)
        _this.control = L.Routing.control({
          waypoints: [
            L.latLng(_this.currentLocation.lat, _this.currentLocation.lng),
            L.latLng(dd[dd.length - 1][0], dd[dd.length - 1][1])
          ]
        }).addTo(this.map)
        _this.control._container.style.display = 'none'
        setTimeout(function () {
          this.getSOSData()
        }.bind(this),
        3000)
      })
    },
    geoLocation () {
      let _this = this
      navigator.geolocation.getCurrentPosition(position => {
        this.currentLocation = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        }
        let redIcon = L.icon({
          iconUrl: _this.red,
          iconSize: [30, 30]
        })
        L.marker([_this.currentLocation.lat, _this.currentLocation.lng], { icon: redIcon }).addTo(_this.map)
        _this.getMessages()
        _this.getSOSData()
      })
    },
    getMessages () {
      const URL = baseUrl.baseUrl_NodeProxy + '/pothole_data'
      // const URL = 'https://192.168.1.5:5000/pothole_data'
      let _this = this
      axios.get(URL).then(response => {
        let dd = response.data
        for (var i = 0; i < dd.length; i++) {
          let yellowIcon = L.icon({
            iconUrl: _this.yellow,
            iconSize: [25, 25]
          })
          L.marker([dd[i].latitude, dd[i].longitude], { icon: yellowIcon }).addTo(_this.map)
        }
        setTimeout(function () {
          this.getMessages()
        }.bind(this),
        3000)
      })
        .catch(error => {
          this.errorMessage = error.message
          this.$notify.error({
            message: 'Error In Getting Messages'
          })
        })
    }
  }
}
</script>

<style scoped>
#mapContainer {
   position: absolute;
   width: 100%;
   height: 100%;
   overflow :hidden;
   z-index: 0;
 }
 .restaurant-icon {
   height: 25px;
   width: auto;
 }
 .map-pannel {
    width: 100%;
    height: 700px;
    margin-top:47px;
 }
 @media(max-width:900px) {
.xs-pad-top30x {
  padding-top: 30px !important;
}
}
</style>
